require File.expand_path('../node_heplers', __FILE__)
require File.expand_path('../search_heplers', __FILE__)

module Trees
  module Binary
    class Node
      include NodeHelpers
      include SearchHelpers

      attr_accessor :parent, :left, :right
      attr_accessor :data

      def initialize(data, parent: nil)
        self.parent = parent
        self.data = data
      end

      def root?
        parent.nil? ? true : false
      end

      def insert(value)
        case data <=> value
          when 1 then insert_left(value)
          when -1 then insert_right(value)
          when 0 then false
        end
      end

      alias :<< :insert

      private

      def insert_left(value)
        if left
          left.insert(value)
        else
          self.left = Node.new(value, parent: self)
        end
      end

      def insert_right(value)
        if right
          right.insert(value)
        else
          self.right = Node.new(value, parent: self)
        end
      end
    end
  end
end